You signed in with another tab or window. Reload to refresh your session.You signed out in another tab or window. Reload to refresh your session.You switched accounts on another tab or window. Reload to refresh your session.Dismiss alert
Copy file name to clipboardexpand all lines: solution/1800-1899/1866.Number of Ways to Rearrange Sticks With K Sticks Visible/README_EN.md
+6-4
Original file line number
Diff line number
Diff line change
@@ -83,9 +83,7 @@ $$
83
83
84
84
The final answer is $f[n][k]$.
85
85
86
-
We notice that $f[i][j]$ is only related to $f[i - 1][j - 1]$ and $f[i - 1][j]$, so we can use a one-dimensional array to optimize the space complexity.
87
-
88
-
The time complexity is $O(n \times k)$, and the space complexity is $O(k)$. Here, $n$ and $k$ are the two integers given in the problem.
86
+
The time complexity is $O(n \times k)$, and the space complexity is $O(n \times k)$. Where $n$ and $k$ are the two integers given in the problem.
89
87
90
88
<!-- tabs:start -->
91
89
@@ -184,7 +182,11 @@ function rearrangeSticks(n: number, k: number): number {
We notice that $f[i][j]$ is only related to $f[i - 1][j - 1]$ and $f[i - 1][j]$, so we can use a one-dimensional array to optimize the space complexity.
188
+
189
+
The time complexity is $O(n \times k)$, and the space complexity is $O(k)$. Here, $n$ and $k$ are the two integers given in the problem.
Copy file name to clipboardexpand all lines: solution/1800-1899/1877.Minimize Maximum Pair Sum in Array/README_EN.md
+44-4
Original file line number
Diff line number
Diff line change
@@ -93,7 +93,13 @@ The maximum pair sum is max(3+5, 4+4, 6+2) = max(8, 8, 8) = 8.
93
93
94
94
<!-- solution:start -->
95
95
96
-
### Solution 1
96
+
### Solution 1: Greedy
97
+
98
+
To minimize the maximum pair sum in the array, we can pair the smallest number with the largest number, the second smallest with the second largest, and so on.
99
+
100
+
Therefore, we can first sort the array, then use two pointers to point to the two ends of the array. Calculate the sum of the numbers pointed to by the two pointers, update the maximum pair sum, then move the left pointer one step to the right and the right pointer one step to the left. Continue this process until the two pointers meet, and we will get the minimum maximum pair sum.
101
+
102
+
The time complexity is $O(n \times \log n)$, and the space complexity is $O(\log n)$. Here, $n$ is the length of the array $\textit{nums}$.
97
103
98
104
<!-- tabs:start -->
99
105
@@ -103,8 +109,7 @@ The maximum pair sum is max(3+5, 4+4, 6+2) = max(8, 8, 8) = 8.
103
109
classSolution:
104
110
defminPairSum(self, nums: List[int]) -> int:
105
111
nums.sort()
106
-
n =len(nums)
107
-
returnmax(x + nums[n - i -1] for i, x inenumerate(nums[: n >>1]))
112
+
returnmax(x + nums[-i -1] for i, x inenumerate(nums[: len(nums) >>1]))
108
113
```
109
114
110
115
#### Java
@@ -128,7 +133,7 @@ class Solution {
128
133
classSolution {
129
134
public:
130
135
int minPairSum(vector<int>& nums) {
131
-
sort(nums.begin(), nums.end());
136
+
ranges::sort(nums);
132
137
int ans = 0, n = nums.size();
133
138
for (int i = 0; i < n >> 1; ++i) {
134
139
ans = max(ans, nums[i] + nums[n - i - 1]);
@@ -165,6 +170,41 @@ function minPairSum(nums: number[]): number {
0 commit comments